#include <stdlib.h>
#include <stdio.h>
#if (!defined(Linux))
#if ( defined(SunOS) && (OSMVER < 5))
#define NULL ((void *)0)
#endif
#endif

#include "fec.h"
#include "agent.h"
#include "error.h"
#include <rlcif.h>
#include "rmdpif.h"
#include "rmdp.h"
#include "compat.h"
#include "init.h"

void *rmdp_inst_mngr = NULL;
static int rmdp_init_done = 0;
static fec_codes_t fec_codes[MAX_RMDP_INSTANCES];

int
rmdp_init_()
{
  int i, ret;
    if (rmdp_init_done) return (0);

    rmdp_init_done = 1;
    init_fec();

    if (rmdp_error_init_() < 0)
	return (rlc_internal_set_error_(-1, RMDP_NOERR_H, NULL));
    for (i=0; i<MAX_RMDP_INSTANCES; i++) {
	fec_codes[i].k = 0;
	fec_codes[i].n = 0;
	fec_codes[i].inuse = 0;
    }
    if ((ret = _rlc_init_instance (MAX_RMDP_INSTANCES, &rmdp_inst_mngr))
	< 0) {
	rlc_internal_set_error_ (-1, ret, NULL);
	return ret;
    }
    return (0);
}

void *
get_fec(int k, int n)
{
  int i, j, found;
  void *p = NULL;
    for (i = 0, j = -1, found = 0;
	i < MAX_RMDP_INSTANCES; i++) {
	if (fec_codes[i].inuse > 0 && fec_codes[i].k == k &&
	    fec_codes[i].n == n) {
	    j = i;
	    found = 1;
	    p = fec_codes[i].p;
	    break;
	} else if (j < 0 && fec_codes[i].inuse == 0) {
	    j = i;
	}
    }
    if (j >= 0 && !found) {
	p=fec_new (k, n);
	fec_codes[j].inuse ++; fec_codes[j].k = k;
	fec_codes[j].n = n; fec_codes[j].p = p;
    }

    return p;
}
