#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <strings.h>
#include <assert.h>
#if __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include <sys/types.h>
#include <sys/time.h>

/* #include "compat.h" */
#include "agent.h"
#include "utils.h"

#if __STDC__
void rmdp_my_error (int rmdp_i, char const *fmt, ...)
#else
void rmdp_my_error (rmdp_i, fmt, va_alist)
  int rmdp_i;
  char *fmt;
  va_dcl
#endif
{
  va_list ap;
  char buf[1024];
  rmdp_inst_t *inst;
  int rlc_pi;
#if __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif
#if 1
    if (rmdp_i >= 0 && (inst = (rmdp_inst_t *)_rlc_getinstance(rmdp_i,
	rmdp_inst_mngr)) != NULL)
	rlc_pi = inst->rlc_pi;
    else
	rlc_pi = -1;
    vsprintf(buf, fmt, ap);
    rlc_have_error_ (rlc_pi, -1, buf);
#else
    vfprintf(stderr, fmt, ap);
    fprintf(stderr, "\n");
#endif
    va_end(ap);
    exit(1);
}

unsigned long rmdp_compute_sessid_()
{
  short seed[3];
  struct timeval getime;

    gettimeofday(&getime, NULL);
    seed[0] = (short)getime.tv_usec; seed[1] = (short)(getime.tv_usec*0xffff);
    seed[2] = (short)getime.tv_sec;
    return(nrand48(seed));
}

/* address parsing */
int
rmdp_parse_addr(char *s, char *a, int addrlen, short *p, char *msg)
{
    char *s1, *q = a ;
    strncpy(q, s, addrlen);
    s1=strchr(q,'/');
    if (s1) {
	*p=atoi(s1+1);
	*s1='\0';
	/* NDEB(printf("%s session [%s] [%d]\n", msg, q, ntohs(*p));) */
    } else
	return -1;
    return 0;
}

int
rmdp_n_parse_addr(char *s, char *a, int addrlen, short *p, int *ttl, char *msg)
{
    char *s1, *q = a ;
    strncpy(q, s, addrlen);
    s1=strchr(q,'/');
    if (s1) {
	s1=strchr(s1+1, '/');
	if (s1) {
	    *ttl = atoi(s1+1);
	    *s1='\0';
	} else
	    *ttl = -1;
    }
    return (rmdp_parse_addr(a, a, addrlen, p, msg));
}
